#include "stdafx.h"
#include <atlstr.h>
#include "StatManager.h"
#include "tipconst.h"
#include "HttpClient/httpclient.h"
#include "logconst.h"
namespace tipcommon
{

CString IStatManager::MakeBaseLog()
{
	CString LogUrl(GetStatUrl());
	LogUrl += LOG_DELIMITER_SUB;
	switch(GetOwner())
	{
	case Owner::Installer:
		LogUrl += LOG_OWNER_INSTALLER;
		break;
	case Owner::Updater:
		if (GetEntry() == Entry::AlarmView)
			LogUrl += LOG_OWNER_ALARM;
		else
			LogUrl += LOG_OWNER_UPDATER;
		break;
	}
	return LogUrl;
}

BOOL IStatManager::SendInstallLog(LPCTSTR guid)
{
	CString LogUrl = MakeBaseLog();
	SetEntry(Entry::MainView);

	LogUrl += LOG_DELIMITER_ACTION;
	LogUrl += LOG_ACTION_INSTALL;

	LogUrl += LOG_DELIMITER_APP;
	LogUrl += guid;

	tipbase::GenericHTTPClient httpClient;
	httpClient.Request(NULL, LogUrl);

	tipbase::GenericHTTPClient httpNClicks;
	httpNClicks.SetNclicks();
	httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=ins.install&u=about%3Ablank&nsc=tools.app&m=0"));		

	return TRUE;
}

BOOL IStatManager::SendUpdateLog(LPCTSTR guid)
{
	CString LogUrl = MakeBaseLog();
	SetEntry(Entry::MainView);

	LogUrl += LOG_DELIMITER_ACTION;
	LogUrl += LOG_ACTION_UPDATE;

	LogUrl += LOG_DELIMITER_APP;
	LogUrl += guid;

	tipbase::GenericHTTPClient httpClient;
	return httpClient.Request(NULL, LogUrl);
}

BOOL IStatManager::SendRemoveLog(LPCTSTR guid)
{
	//   信 ϴ.
	SetEntry(Entry::MainView);
	CString LogUrl = MakeBaseLog();

	LogUrl += LOG_DELIMITER_ACTION;
	LogUrl += LOG_ACTION_DELETE;

	LogUrl += LOG_DELIMITER_APP;
	LogUrl += guid;

	tipbase::GenericHTTPClient httpClient;
	return httpClient.Request(NULL, LogUrl);
}

BOOL IStatManager::SendStartPageLog()
{
	CString LogUrl = MakeBaseLog();
	SetEntry(Entry::MainView);

	LogUrl += LOG_DELIMITER_ACTION;
	LogUrl += LOG_ACTION_STARTPAGE;

	tipbase::GenericHTTPClient httpClient;
	httpClient.Request(NULL, LogUrl);

	tipbase::GenericHTTPClient httpNClicks;
	httpNClicks.SetNclicks();
	httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=ins.home&u=about%3Ablank&nsc=tools.app&m=0"));		

	return true;
}

BOOL IStatManager::SendDefaultSearchLog()
{
	CString LogUrl = MakeBaseLog();
	SetEntry(Entry::MainView);

	LogUrl += LOG_DELIMITER_ACTION;
	LogUrl += LOG_ACTION_DEFAULTSEARCH;

	tipbase::GenericHTTPClient httpClient;
	httpClient.Request(NULL, LogUrl);

	tipbase::GenericHTTPClient httpNClicks;
	httpNClicks.SetNclicks();
	httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=ins.search&u=about%3Ablank&nsc=tools.app&m=0"));		

	return true;
}

BOOL IStatManager::SendInstallUpdaterLog()
{	
	CString LogUrl = MakeBaseLog();
	SetEntry(Entry::MainView);

	LogUrl += LOG_DELIMITER_ACTION;
	LogUrl += LOG_ACTION_INSTALLUPDATER;

	tipbase::GenericHTTPClient httpClient;
	return httpClient.Request(NULL, LogUrl);
}

BOOL IStatManager::SendHideOtherToolbarLog()
{
	//ٸ   κ信 ִ.
	SetEntry(Entry::MainView);
	CString LogUrl = MakeBaseLog();	

	LogUrl += LOG_DELIMITER_ACTION;
	LogUrl += LOG_ACTION_HIDEOTHERTOOLBAR;

	tipbase::GenericHTTPClient httpClient;
	httpClient.Request(NULL, LogUrl);

	tipbase::GenericHTTPClient httpNClicks;
	httpNClicks.SetNclicks();
	if( this->GetOwner() == Owner::Installer )
	{
		httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=ins.hidetb&u=about%3Ablank&nsc=tools.app&m=0"));
	}
	else
	{
		httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=mng.hidetb&u=about%3Ablank&nsc=tools.app&m=0"));
	}

	return TRUE;
}

InstallerStatManager::InstallerStatManager(LPCTSTR url)
{
	_tcscpy_s(m_Url, tipbase::MAXURL, url);
}

UpdaterStatManager::UpdaterStatManager(LPCTSTR url):m_Entry(Entry::MainView)
{
	_tcscpy_s(m_Url, tipbase::MAXURL, url);
}


};